Recent

Author Topic: Fpcupdeluxe  (Read 443624 times)

Alextp

  • Hero Member
  • *****
  • Posts: 1058
    • UVviewsoft
Re: Fpcupdeluxe
« Reply #1605 on: June 22, 2020, 09:17:54 pm »
Ubuntu 20.4 x64
1) I did all needed steps at
https://wiki.lazarus.freepascal.org/index.php/Cross_compiling#From_Linux_x64_to_Linux_i386
I have all packages, apps

2) I installed last deluxe 1.6.8x to new empty dir
3) Installed there FPC 3.3 today trunk for Linux x64
4) Installed there cross Linux x64-> Linux x32
And on making Lazarus LCL app I get errors
Quote
Compile Project, Mode: linux x32 gtk2, CPU: i386, Target: builds/linux-x32-gtk2/cudatext: Exit code 1, Errors: 1, Warnings: 12
Warning: linker: /usr/bin/ld: /home/user/fpcupdeluxe_alt/fpcupdeluxe/cross/lib/i386-linux//libpthread.so: undefined reference to `__libc_vfork@GLIBC_PRIVATE'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_ref_count_inc'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_spawn_async_with_fds'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_ref_count_dec'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_unix_get_passwd_entry'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_canonicalize_filename'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_atomic_ref_count_init'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_atomic_ref_count_inc'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_utf8_validate_len'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_source_set_dispose_function'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_ref_count_init'
Warning: linker: /usr/bin/ld: /usr/lib/i386-linux-gnu/libgio-2.0.so.0: undefined reference to `g_atomic_ref_count_dec'
cudatext.lpr(36,1) Error: Error while linking
------
Can you improve deluxe to work with cross Linux 64->32 out of the box?

Alextp

  • Hero Member
  • *****
  • Posts: 1058
    • UVviewsoft
Re: Fpcupdeluxe
« Reply #1606 on: June 22, 2020, 09:20:30 pm »
More info: my fpc.cfg is
http://uvviewsoft.com/c/fpc.cfg

ASBzone

  • Sr. Member
  • ****
  • Posts: 452
  • Automation leads to relaxation...
    • Free BrainWaveCC Console Utilities
Re: Fpcupdeluxe
« Reply #1607 on: June 28, 2020, 10:26:18 pm »
New release of fpcupdeluxe, celebrating the release of stable FPC 3.2.0  !!
This FPC supports the mORMot in all its features.
And has many more very important improvements and bugfixes.

https://github.com/LongDirtyAnimAlf/fpcupdeluxe/releases/latest

Thanks, Don!

On one machine, I selected FIXES *AND* FIXES with v1.68x, and I ended up with the following:


Lazarus = 2.0.9 r63480
FPC =  3.2.0 r45705

Compiling software works, although this is the message I receive with 32-bit cross-compiles:


Free Pascal Compiler version 3.2.0-beta-r41227 [2019/02/06] for i386

(64-bit mode doesn't give any info here)  -- weird date for the build, it seems.


On a different machine, I instead chose 3.2.0 *AND* FIXES with v1.68x, and I ended up with the following:

Code: [Select]
fpcupdeluxe: ERROR: FPCNativeInstaller (CheckModule: FPC): sources error (URL mismatch).[/font]
fpcupdeluxe: ERROR: FPCNativeInstaller (CheckModule: FPC): desired URL=https://svn.freepascal.org/svn/fpc/tags/release_3_2_0
fpcupdeluxe: ERROR: FPCNativeInstaller (CheckModule: FPC): source URL=https://svn.freepascal.org/svn/fpc/branches/fixes_3_2/


ERROR: Fpcupdeluxe fatal error !
Sequencer (FPC): Failure running fpcupdeluxe: error executing sequence FPC
Sequencer (Default): Failure running fpcupdeluxe: error executing sequence Default

??
-ASB: https://www.BrainWaveCC.com

Lazarus v2.0.11 r63516 / FPC v3.2.1-r45705 (via FpcUpDeluxe) -- Windows 64-bit install w/32-bit cross-compile
Primary System: Windows 10 Pro x64, Version 2004 (Build 19041.388)
Other Systems: Windows 10 Pro x64, Version 2004 or greater

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1324
Re: Fpcupdeluxe
« Reply #1608 on: June 29, 2020, 12:59:17 pm »
Strange.
Fixes gives me FPC 3.2.1 rev 45705
Stable gives me FPC 3.2.0 rev 45643

The error you see is caused by the fact that fixes and stable have different URL.
https://svn.freepascal.org/svn/fpc/branches/fixes_3_2/
https://svn.freepascal.org/svn/fpc/tags/release_3_2_0/
SVN does not handle an URL switch very well. You can tell fpcupdeluxe to try to switch. But my advice would be to maintain two different installs. Stable is a one-time-install, fixes an install that can be updated.

OkobaPatino

  • Jr. Member
  • **
  • Posts: 84
Re: Fpcupdeluxe
« Reply #1609 on: July 06, 2020, 09:52:03 am »
Thanks @DonAlfredo for this lovely tool.
When a user installs the default Lazarus setup, it will associate source files to it, so you can have explorer icon and other options like context menu.
Can I ask is there such option for Lazarus versions installed by Fpcupdeluxe?

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1324
Re: Fpcupdeluxe
« Reply #1610 on: July 06, 2020, 03:19:51 pm »
@OkobaPatino
You're welcome !

Fpcupdeluxe is a tool to install FPC and Lazarus and 3rd party packages, WITHOUT changing your system settings or other installs of FPC and Lazarus. Much effort goes into this isolation. That should enable users to play/test with various FPC and Lazarus versions. Therefor, context will not be touched.

Sidenote.
FPC stable (3.2.0) and Lazarus stable (2.0.8 / 2.0.10) are very (VERY) good releases. I would advice you to use these. And install them through the available official installers.

OkobaPatino

  • Jr. Member
  • **
  • Posts: 84
Re: Fpcupdeluxe
« Reply #1611 on: July 06, 2020, 03:32:21 pm »
Sure I know but I like to work with Trunk and use it by default for my daily work.
That is a good option to have as Fpcupdeluxe has almost all the options I needed for my daily development needs and its been a long time that I didn't use stable official installer.
I think with some changes it can be a serious option for installing and working with Lazarus and FPC and not only plat/test.

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1324
Re: Fpcupdeluxe
« Reply #1612 on: July 06, 2020, 03:43:40 pm »
Ok. Will look into this, and make it an option if possible.
With one limitation: fpcupdeluxe should/will never run as a privileged user. So, if root-like permissions are needed for context changes, it might be difficult to implement.
PS: are you on Windows or Linux or else ?

Alextp

  • Hero Member
  • *****
  • Posts: 1058
    • UVviewsoft
Re: Fpcupdeluxe
« Reply #1613 on: July 06, 2020, 03:53:35 pm »
Don, can we have support for cross to Linux x32 on Linux x64? Please...
https://github.com/LongDirtyAnimAlf/fpcupdeluxe/issues/242

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1324
Re: Fpcupdeluxe
« Reply #1614 on: July 06, 2020, 04:11:58 pm »
@Alextp

I am still a bit busy with crossing towards xtensa/freertos on Windows and Linux.
Will look into this issue as well.

First thoughts.
Fpcupdeluxe has detected that your systems own native binary utilities are able to generate both 64 and 32 bit. So, the tools for Linux 32bit are not downloaded.
In that case, fpcupdeluxe should also ONLY use the 32bit libs that are available on your system.
But it does not, according to your fpc.cfg
Please try change in fpc.cfg:
-Fl/home/user/fpcupdeluxe/fpcupdeluxe/cross/lib/i386-linux
to
-Fl/usr/lib/i386-linux-gnu

Alextp

  • Hero Member
  • *****
  • Posts: 1058
    • UVviewsoft
Re: Fpcupdeluxe
« Reply #1615 on: July 06, 2020, 04:41:26 pm »
That replacement gave the new error
Quote
cudatext.lpr(36,1) Warning: "crti.o" not found, this will probably cause a linking failure
cudatext.lpr(36,1) Warning: "crtbegin.o" not found, this will probably cause a linking failure
cudatext.lpr(36,1) Warning: "crtend.o" not found, this will probably cause a linking failure
cudatext.lpr(36,1) Warning: "crtn.o" not found, this will probably cause a linking failure
Warning: linker: /usr/bin/ld: skipping incompatible /usr/lib/x86_64-linux-gnu/libglib-2.0.so when searching for -lglib-2.0
Warning: linker: /usr/bin/ld: skipping incompatible /usr/lib/x86_64-linux-gnu/libglib-2.0.a when searching for -lglib-2.0
Warning: linker: /usr/bin/ld: cannot find -lglib-2.0
cudatext.lpr(36,1) Error: Error while linking

user@user-Notebook:~$ sudo apt install libglib2.0-0:i386

Quote
Reading package lists... Done
Building dependency tree       
Reading state information... Done
libglib2.0-0:i386 is already the newest version (2.64.2-1~fakesync1).
libglib2.0-0:i386 set to manually installed.
0 upgraded, 0 newly installed, 0 to remove and 20 not upgraded.
user@user-Notebook:~$
« Last Edit: July 06, 2020, 04:44:15 pm by Alextp »

totya

  • Hero Member
  • *****
  • Posts: 627
Re: Fpcupdeluxe
« Reply #1616 on: July 06, 2020, 04:59:14 pm »
FPC stable (3.2.0) and Lazarus stable (2.0.8 / 2.0.10) are very (VERY) good releases. I would advice you to use these. And install them through the available official installers.

Hi!

2.0.10/3.2.0 not available yet with official installers (for windows)... but with your app is possible :)

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1324
Re: Fpcupdeluxe
« Reply #1617 on: July 06, 2020, 05:40:31 pm »
I guess you have installed: libc6-dev-i386 ?

Reminder. However.
Lazarus linking and Lazarus running are two different things.
It might be that you have a 32 bit libglib-2.0.so.0
But when linking Lazarus, you also need a libglib-2.0.so
So, make symlinks towards the reported libs.

This is a known (and annoying) issue, if you search around in the forum.

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1324
Re: Fpcupdeluxe
« Reply #1618 on: July 06, 2020, 05:42:34 pm »
@totya
Well. To be honest (and perhaps trivial). I use fpcupdeluxe myself to install (also) the stable versions !
 :D
But also, due to the easy install of cross-compilers that I need for building fpcupdeluxe myself.

OkobaPatino

  • Jr. Member
  • **
  • Posts: 84
Re: Fpcupdeluxe
« Reply #1619 on: July 06, 2020, 06:33:01 pm »
@DonAlfredo Windows and the code is already in the Lazarus setup I think. The need for admin can be implemented easily in windows and I can help with that if you like. Such feature can be in Setup+ so it can be used if needed for users the need it like me.

 

TinyPortal © 2005-2018